SteinBlume. CP/M Disk Image Explorer. Version history.

+ Added new feature.
* Modified feature / Fixed bug.

v1.3.2.1410 (17.02.2019)
* Disabel validation of "Number of Disk Cylindres" and "Number of Sectors on Track" parametres;
* Added the ability to group change the attributes of selected files.

v1.3.0.1408 (7.11.2017)
+ Added experimental "direct" support for Amstrad DSK disk images;
+ In the "Settings" added the ability to choose the default interface language, with the change "on the fly";
Command-line options for forced language selection (-l ru or --lang ru) are also saved.
* Fixed a bug that does not allow in some cases to save a disk image with a number of blocks less than 256;
+ Lister. Added viewing of graphic BLK files created in the GRAF package for ATM (Many thanks to Maxim Timonin for help);
+ Lister. When viewing Spectrum BASIC, the ability to enable/disable the display of control (non-print) codes, real values of numbers was added;
In the "Settings" option is added the ability to customize the display by default.
+ Lister. Added disasm view mode in Intel 8080 and Z80 mnemonics;
For CP/M COM files and +3 DOS code files, these modes are used as default view modes. In the "Settings" also appeared options related to these viewing modes.
* Lister. Fixed viewing bug in text mode for +3 DOS;
* Fixed minor bugs.

v1.2.1.1401 (1.09.2017)
+ Lister. Added support for viewing GRF graphic files with a palette (Profi);
* Various minor changes;
* Fixed minor bugs.

v1.2.0.1400 (8.03.2017)
+ Added Image properties dialog (Alt+Enter);
+ Added the ability to open the disk image file by passing its name as command line parameter (Thanks to barsik for idea);
+ Added feature for save Open/Save image, Add/Extract files operations last paths;
Added option in Settings. By default, this option is enabled.
+ Added Ctrl+A for Select/Unselect all files;
The cursor is not necessarily located in the file list.
+ Added function for Calculate unused space in last block of files;
Added in Main Menu.
+ Added creation of Orion disk image with custosmized parameters;
For it You must select "Customize" instead system file in Create Image File dialog. After that Define format pareameters dialog will be opened, where You may define all parameters or select one of four presets. 
(Thanks to barsik for this four new features).
* Hotkey for Settings dialog changed to Ctrl+Enter;
* Change the error handling when opening a file;
When you open the image, if the image format is unidentified, you can now choose the option of further actions:
- open the Image by using the parameters of the previous open Image,
- open the Image by using the default parameters,
- open Image as .xdi (by custom parameters).
* Change the error handling when opening a file;
Now if the error exceeds the maximum block number, the operation of opening the Image is not interrupted. The processing of the entry in the directory that caused the error is skipped. At the end of the opening operation, displays a list of errors occurred when the file was opened (optional, the output of errors is disabled by default).
* Fixed error with creation of new Image file;
It is making it impossible to save the Image.
+ Added four new options for +3DOS in Settings;
+ Added function for add header to an existing +3DOS file;
+ Added Orion HDD Images support (without creation of new image);
When You open the HDD Image file, original Image file backup automatically (this can be disabled in the Settings, but it is not recommended), and all work is done with a copy of the Image. The thing is that the work of the utility with a way HDD occurs somewhat differently than with FDD Images. Disk images are loaded into memory, after which all manipulations occur there, and the original image remains intact while the save function are not used. Work as a way HDD goes directly to the Image file, that is, all actions (Delete/Rename files, Add files, ...) occur immediately in the Image and Save the image does not require. In addition, work with the HDD at the moment is not good enough. So just in case I recommend You do not disable the Backup option.
+ When extracting files from an image, the file name characters are checked for validity now;
Symbol to replace invalid characters added to the Settings.
+ Added option to ignore "deleted" files when you open an Image (disabled by default);
In some cases, the presence of "deleted" files in the Image may cause an error when You try to open the Image. Try using this option.
+ Added the ability to drag and drop files from SteinBlume out (into Explorer, other applications or other instance of SteinBlume);
As a result, little has changed the logic when you drag files between the user areas. Now change the transfer/copy mode (Shift) at any time prior to mouse button is released (it is more logical and more comfortable). Changed the appearance of the cursor for these operations to the standard for Windows.
* Fixed Scorpion Disk Image Open (broke in version 1101386);
* Lister: Fixed select text encoding when it saving from Lister.
* Lister. Now, the text encoding is determined automatically (you can turn it off in Settings);
* Lister. Changed the hotkey combination for the ATM encoding (Ctrl + M);
* Lister. Fixed Tab display;
* Lister. Fixed viewing WIN images (Korvet).
The colors were confused.
* Fixed minor bugs.

v1.1.1.1388 (25.07.2016)
* Repair the function of transfer/copy files between the users areas (broken in v1.0.0.1373 (12.04.2016)). Thanks to KTSerg for bug-report.

v1.1.0.1386 (23.07.2016)
* Fixed Byte-01 images saving;
* Fixed renaming;
The Del key when renaming no longer causes the function to delete a file.
* Fixed adding files in image by drag'n'drop;
Now, when you add in image of a group of files, a message "No free space!" is displayed only once, not for each file, and with the same name, pressing Cancel will cancel the all adding operations with all files.
* Modified "Open as .xdi" function;
Now, with this function you can try to open a file with any extension.
* Modified files extracting function;
Previously, it was impossible to extract the file, in which the name has invalid characters. Now, these characters will automatically be replaced by a special character, set in the Settings.
* Fixed minor bugs;
+ Lister: Added a viewing of Vector-06C graphics files. Thanks to KTSerg, Ivan Gorodetsky (ivagor), AzAtom, PRSoft;
Supported the following file formats:
 - BSV - Vector-06C screen dump. Currently supported only mode of 256x256 pixels. If the disc (in the same user area that the file itself) is also stored palette file (must have the same name as that of the image file, and the extension "PAL"), then the view will be used palette from this file, otherwise case palette BASIC 2.5 will be used;
 - RBR / RMB - "Rembrandt" editor files;
 - SCR - "Pencil" editor files. Supported the expansion by PRSoft - the ability to use an external palette file, whose name should be written in the image file instead of the Pencil's author's phone number(bytes 05-0F) and supplemented by spaces.
ATTENTION! THIS FEATURE IS NOT TESTED ON REAL FILES! In the absence of a reference to the palette (standard format), used BASIC 2.5 palette;
 - SPR - "Draw" editor files.
+ Lister: Added a viewing of Korvet Screen dumps;
Detected by size.
+ Lister: Added a viewing of "Grin" editor files (Korvet);
Supported the following file formats:
 - PIC - Korvet screen dump;
 - GRF - packed Korvet screen dump;
 - WIN - window (of Korvet screen).
+ Lister: Added a viewing of "Abris" editor files (extention "ABR") (Korvet).

v1.0.0.1373 (12.04.2016)
(*) Project renamed to SteinBlume. CP/M Disk Image Explorer;
(*) File viewer renamed as Lister, similar  to Lister in Total Commander by Christian Ghisler;
Is not material, but here and elsewhere I will call it as such (to me so easy).
+ Added support of fdd disk images as Vector-06C CP/M disk images. Inaccuracies are possible;
+ Added Del hotkey for file(s) deleting. F8 also works;
+ Added Disk Image Map tool (Ctrl + M). Attention! Due to the specifics of the utility, the Map is only displays the original location of the files in the Image (before the editing of the Image);
  Functional:
  - When you select a file from the list on the left, on the Map to select Blocks occupied by them, Map scrolls so that the first Block occupied by the file is displayed in sight, at the bottom of window displays information about the file, list of numbers of Blocks occupied by them, and information about the first Block occupied by the file;
  - With the click on the Map selects Block and displays information about the Block;
  - When you double-click on the Map, if the Block is occupied by file, there is the same as when you select a file from the list, but the Map does not scroll, If the Block is not occupied by file, the reaction is similar to a single click.
+ Added (returned) ZS Scorpion support;
+ Added files headers editor for +3 DOS Images;
* Modified reaction to the Block number in a directory that exceeds the maximum value. Now, if the number is found in the location map of "deleted" file, the size of the file is set to 0 (May be It makes sense to exclude it from the list), and Image further processing is not interrupted with an error (as was earlier), but continues on;
+ Added output of the file type in the list of image files for +3 DOS Images;
+ Added the function of ASCII-string / sequence of bytes search in files in Image (Ctrl + F). Displays the list of files found with the sample and the offset from the beginning of the file. You can view files found in Lister (F3);
* Fixed minor interface bugs;
* Rewrited the Opening Image function. There may be new bugs:) Now are opened Images with the Software Skewed Sectors;
More information about the Software Skewed Sectors: In fact it is a regular interleave, ie sectors of track reads is not in the order but with some offset (for example: 1, 3, 5, 7, 9, 2, 4, 6, 8, 10). A distinctive feature of Software Skewed Sectors is that on a floppy disk sector numbers remained the same, that is, the reading numbers of a sector header on a disk does not provide any information about the order in which the reading sector actually. As a result, the Images obtained from these discs, obtained "intermixed". Information about the order in which to make read / write access, the OS stored in a special table. It is logical to assume that the system tracks "do not mix", therefore, the current version of the utility "does not order" them, only sector of tracks going from system. All this is just a result of my speculations, and can absolutely not meet reality. So please, if anything, to correct me.
* Rewrited the Saving Image function. There may be new bugs:)
* Fractionally rewrited the Add File to Image function. About the possible consequences of looking up:)
* Fractionally rewrited the Extract File(s) from Image function. About the possible consequences of looking up:)
* Fractionally rewrited the Creating New Image function. About the possible consequences of looking up:)
* Fractionally rewrited the Saving System Tracks function. About the possible consequences of looking up:)
+ Added "format_id" xdi parameter - replacement and addition for file extention, string specifies the utility for additional properties inherent to the given format;
These strings are written in the program code in the form of constants. This version is processed only one such constant (format_id=PLUS3DOS), indicating that the Image to be processed, as a way of +3 DOS.
+ Added "date_stamp" xdi parameter, indicating a format for storing dates of files in a directory;
It can take 3 values:
  0 - (default) format does not support dates of files storage,
  1 - the dates of the files stored on the CP/M standard,
  2 - non-standard (for CP/M) date storage format (used for example in Z80DOS and DOS +).
In this version, support for dates is not implemented. Disk Images using storage dates, when set parameter to 1 or 2, are opened correctly, but the actual date is nowhere displayed and subsequently will not be saved to the Image.
* Changed the interpretation of dsm parameter (-> BlNo-1);
On the work of utility  this parameter is not affected, since it is not used in the processing of the Image.
+ Added "As Defult" button in "Edit .xdi values" dialog for saving values in settings as default.
+ Added "Default" button in "Edit .xdi values" dialog for restoring default values from settings. And modified logic of the storage of the values of this dialogue. Now, the value entered by the user does not change each time you open the dialog to the default values.
+ Added simple editing mode of disk parameters in "Edit .xdi values" and "Settings - .xdi settings" dialogues;
* Fixed work with Disk Images, when the Extent size is greater than 16k;
+ Added ability to loading/saving .xdi parameters from/to a file in "Edit .xdi values" and "Settings - .xdi settings" dialogues;
* Fixed processing of 1-byte allocation map;
* Changed the logic of calculation of free space;
Now free space value is calculated based on the number of Sectors and Tracks of the Image rather than the size of the original Image file. This is, firstly, excludes "extra" Tracks from the Disk space (Disk format can often be a greater number of Tracks, but for CP/M, these Tracks were not visible), secondly, the ability to correctly display the available space for the Images, with cropped empty Tracks. In the second case (if the Image file is less typical) issued a warning.
* Completed yet the "Settings" dialog.
+ Lister: Added viewing of BASIC for Korvet Images;
+ Lister: Added viewing of .ZAS pictures for Korvet Images;
+ Lister: Added full viewing mode;
Actual only for Plus3DOS files now. For them, the file is displayed fully, when the mode enabled (together with the header and the "trash in the tail") (Ctrl + V).
+ Lister: Added KOI7 text encodings: H1 and H2 (Ctrl + 1, Ctrl + 2);
+ Lister: Added search for text function (Ctrl + F);
+ Lister: Lister now works in a multi-windowed mode;
+ Lister: Added viewing of BASIC for +3DOS Images;
For all other (not BASIC) files displayed when viewing only the real part, according to contents of +3DOS header.
+ Lister: Added viewing of Screen files (both with attributes, and without) for +3DOS files with +3DOS header and without. While the minimum functions:
  - Zoom by keys "-" and "+",
  - Enable/disable attributes (Key A),
  - Round enumeration of INK, PAPER colors (Keys I, P) for "without attributes" mode, BORDER colors (Key B),
  - Change the color palette by pressing Key C (now is realized two palette in the program: color and  pseudo-monochrome),
  - Reset color settings (Key P),
  - Export to scr, png, bmp, hobeta.
Support for FLASH is not implemented yet.
* Lister: Fixed error with displaying text in Lister;
+ Disk Image Analyzer v2.2: Added DSK Image files support;
+ KDI Checksum Reader: Added export DPB, DPH parameters to SteinBlume in "Edit .xdi values" dialog.
Function has no practical use, and (may be) no longer works now:)

v0.5.1.1362 (7.09.2015)
+ Added Splitter between USER list and Files list;
* Fixed GUI bugs, when the window is resized (Thanks to Creator for bug report);
* Fixed some GUI bugs.

v0.5.0.1361 (6.09.2015)
* Modified "Tools" menu . FDI Analyzer and Teledisk Analyzer are replaced by Disk Image Analyzer;
* Deleted all beginnings of FDI and Teledisk support. Now this functions are realized in Disk Image Analyzer;
* Fixed some GUI bugs;

v0.4.1.1360 (30.08.2015)
+ Added multi-language interface (English and Russian now. Write to me at era_cg@speccy.su for more information);
+ Added "Tools" menu item for launch Additional Utilities, if they was installed;
* Slightly speeded file viewer.

v0.4.0.1359 (26.08.2015)
+ Added support of user's (eXperimental) format files (xdi).
Introduced the concept of the so-called xdi file (eXperimental Disk Image or simply X Disk Image). Now in more detail. The utility adds the possibility of opening (creating, modifying, saving) of Images, which are not supported "from the box". To do this, users need to know (choose correctly) DPH & DPB parameters. Next to open the file can be 2 ways: or change Image file extension to ".xdi" and open the Image file as usual, or use menu item "Open Image As .xdi". After that he will be asked to fill DPH and DPB parameters (the default values are set in Settings). Then, the Image file will be opened like any other. Check the adequacy of of the entered data is not made, is why I recommend to use this function with extreme caution. That's all.

v0.3.2.1356 (5.03.2014)
+ Added Byte-01 support (thanks for this our friend from Poland - Gelip);
* Small cosmetic changes in "About" dialog (Now there you can jump directly to the forum zx.pk.ru).

v0.3.1.1355 (1.03.2014)
@ Reanimated the work above the utility;
+ At the request of workers (and specifically Djoni) added the possibility to add groups of files in the Image by drag'n'drop (not one by one as before).

v0.3.1.1354 (9.09.2012)
* Changed calculation of free space.
Previously, the calculation was carried out in space is fundamentally wrong. It was calculated based on the size of the disk and the last occupied block. This resulted in an error if the file is not located in a row, if the two met unoccupied blocks. Now when calculating are count only really busy blocks. Also, now is not taken into account the space occupied by "deleted files";
* Changed work with "deleted files".
Now, when you save an Image, "deleted" files are not saved, about this displayed the warning. If necessary, they can be recovered by transferring into any USER area (Before Image file saving). Because of features of utility, their saving could lead to overflow of the Image (every "deleted file" held its own disk space);
+ Added code page selection (Ansi/UTF-8) for Saving text from file viewer. See in Settings;
+ Added hot keys in the file viewer.
* Fixed display of the editing window when you rename a file.
When the toolbar is switched on, the window was positioned higher than necessary. The error appeared several versions ago, by correcting the other, and I had seen it a couple of days ago.
* Fixed display scrollbar.

v0.3.0.1353 (8.08.2012)
+ Added "Save Text" function in file viewer. Thanks to Djoni for the idea.

v0.3.0.1352 (2.06.2011)
* Fixed processing of big files of Korvet.
As the sample was used Image of English-Russian Dictionary.
* Cosmetic changes in the function view.
Now, in the view title bar also displays the number of the USER area and the file name is displayed without extra spaces;
* Yet another cosmetic change in the function view.
Now, when you change the view mode (Text/Hex) or change the encoding, the desired button on the panel is clamped. Thus always visible, what encoding (and which mode) is current.

v0.3.0.1340 (31.05.2011)
+ Added some hot keys;
+ Added check for Maximal Block number.
At present an error is reported and the Image processing is terminated (maybe it would be better to process, for example, the maximum allowable block);
+ Added code page ISO 8859-5 in file viewer;
+ Added the choice of system for creating an new Image.
Choose computer and the file of system from the list (system files must be placed in a folder /sys/<computer> and have the extension .bin. It can be any correct Image file or only system tracks);
+ Added Saving System tracks operation.
There was an additional item in the "Actions" menu. Not available for АТМ, Profi (since in all ATM Images that I have met, system area was empty, and Profi Images do not have the System area) and Scorpion, as it seems (correct, if not), the same everywhere;
* Fixed minor bugs.
Currently supported are: ATM, Profi, Korvet, Oroin, Quorum, ZS Scorpion (with more bugs).

v0.2.3.792 (06.11.2010)
+ Added code page Profi in file viewer;
+ Added copy operation inside the Image file by drag'n'drop (SHIFT must be pressed);
+ Added check for the existence of a file with the same name in USER area for operations of Transfer/Copy files inside the Image, Rename files, Add File To Image;
* When Renaming files is now permitted both registers (were found Images with file names in lower case);
* Fixed bug of file viewer. Previously, after viewing the file in the HEX mode and switching to the Text mode, after changing the encoding, view mode switched back to HEX;
* Removed flicker when viewing files in HEX mode;
* Fixed bug of "Add File To Image" operation. For adding files is not calculated CRC32;
* Fixed processing of Image files with more than 16 USER areas;
* Fixed minor bugs.

v0.2.2.602 (28.10.2010)
+ Added file transfer from one USER area to another by drag'n'drop. In the same way, you can recover "Deleted files";
+ Added HEX mode in file viewer;
+ Added code pages in file viewer: OEM/DOS (CP866), Windows (CP1251);
* Fixed bug of display of pseudographics in file viewer;
* Fixed bug of "Add File To Image" operation. When you add a file to the newly created image, an error 'Out of bounds' occurred;
* Fixed bug in History.txt (this file). The previous version of the program mistakenly dated 27.10.2010 instead 24.10.2010.:)

v0.2.1.396 (24.10.2010)
+ Added work with "Deleted files" (USER Deleted);
+ Added CRC32 calculation for all files in Image;
+ Added "Settings" dialog;
* Empty USER is highlighted in color now;
* Redesigned the mechanism of renaming files (Now this operation is more visual);
* Changed processing bodies of files (now the size of the file is taken from the number of occupied blocks);
* Fixed processing of file names (Now, the file names are truncated to the size of 8.3. Use only uppercase (lowercase characters converted to uppercase automatically), not allowed symbols and Cyrillic symbols (the list can be changed in Settings) are replaced by a special symbol (specified in the Settings too));
* Fixed minor bugs and omissions.

v0.2.0.152 (17.10.2010)
+ Added USER field (Also added USER with the mysterious name All);
+ Added sorting by clicking on the column header of the table files.

v0.1.0.29 (15.10.2010)
+ Added .atm extension;
* Fixed bug of opening Image, if the program is running from a folder with the cyrillic name.

v0.1.0.21 (13.10.2010)
+ Added feature "Open Image File / Add File To Image" by drag'n'drop (If Image file - will be opened, else - will be added to opened Image);
* Fixed bug of viewing file from Image (F3);
* Fixed bug of saving Image. Now the modified Image will be saved to the folder from which it was opened, but not to the folder where the program is running.

v0.1.0.1 (12.10.2010)
+ First public beta version.

(c) 2010 - 2016 Black Cat / ERA Creative Group
era_cg@speccy.su